namespace BehaviorDesigner.Runtime.Tasks.Basic.Math
{
    [TaskCategory("Basic/Math")]
    [TaskDescription("Performs a comparison between two bools.")]
    public class BoolComparison : Conditional
    {
        [Tooltip("The first bool")]
        public SharedBool bool1;
        [Tooltip("The second bool")]
        public SharedBool bool2;
        public JumpOnObj jump;
        public bool normal;
        public override TaskStatus OnUpdate()
        {
            if (normal)
            {
                return bool1.Value == bool2.Value ? TaskStatus.Success : TaskStatus.Failure;
            }
            else
            return jump.canJump == bool2.Value ? TaskStatus.Success : TaskStatus.Failure;
        }

        public override void OnReset()
        {
            bool1.Value = false;
            bool2.Value = false;
        }
    }
}