﻿using System.Collections;
using System.Collections.Generic;
using UnityEngine;

public class MapMaker : MonoBehaviour
{
    static public GameObject[,] map_Tile;
    static public GameObject[,] map_Item;
    static public GameObject selectedObj;//从点击物体上获取
    static public GameObject selectedPerfabObj;//预制中物体，ui中对应
    public GameObject basicTile;
    
    public int mapLength, mapHeight;
    void Start()
    {
        map_Tile = new GameObject[mapHeight, mapLength];

        map_Item = new GameObject[mapHeight, mapLength];
    }
    public void SetUpMap()
    {
        map_Tile = new GameObject[mapHeight, mapLength];

        map_Item = new GameObject[mapHeight, mapLength];
        for (int i0 = 0; i0 < mapHeight; i0++)
        {
            for (int i1 = 0; i1 < mapLength; i1++)
            {
                map_Tile[i0, i1] = basicTile;
                map_Item[i0, i1] = item_Null;
            }
        }
    }
    
    static public void changeMap(GameObject selectedPerfabObj)
    {
        Debug.Log("Change" + selectedObj.GetComponent<TileState>().lNumber + "   " + selectedObj.GetComponent<TileState>().hNumber);

        GameObject replaceTile = (GameObject)Instantiate(selectedPerfabObj, selectedObj.transform.position, selectedObj.transform.rotation, selectedObj.transform.parent);
        replaceTile.GetComponent<TileState>().lNumber = selectedObj.GetComponent<TileState>().lNumber;
        replaceTile.GetComponent<TileState>().hNumber = selectedObj.GetComponent<TileState>().hNumber;
        map_Tile[selectedObj.GetComponent<TileState>().hNumber, selectedObj.GetComponent<TileState>().lNumber] = replaceTile;
        GameObject childPast = selectedObj.transform.GetChild(0).gameObject;
        GameObject replaceItem = (GameObject)Instantiate(childPast, selectedObj.transform.GetChild(0).position, selectedObj.transform.GetChild(0).rotation, replaceTile.transform);
        map_Item[selectedObj.GetComponent<TileState>().hNumber, selectedObj.GetComponent<TileState>().lNumber] = replaceItem;
        Destroy(selectedObj);

    }

    public void changeItemInMap()
    {
        if (selectedPerfabObj.tag == "tube") { setUpTubeItem(selectedObj); }

        GameObject childPast = selectedObj.transform.GetChild(0).gameObject;
        GameObject replaceItem = (GameObject)Instantiate(selectedPerfabObj, selectedObj.transform.GetChild(0).position, selectedObj.transform.GetChild(0).rotation, selectedObj.transform);
        //replaceItem.GetComponent<TileState>().lNumber = selectedObj.GetComponent<TileState>().lNumber;
        //replaceItem.GetComponent<TileState>().hNumber = selectedObj.GetComponent<TileState>().hNumber;
        Destroy(childPast);
       map_Item[selectedObj.GetComponent<TileState>().hNumber, selectedObj.GetComponent<TileState>().lNumber] = replaceItem;
        


    }
    public void W_Link(GameObject W)
    {
        setUpLinkedTubeItem(W.transform.parent.gameObject);
        GameObject childPast = W.gameObject;
        GameObject replaceItem = (GameObject)Instantiate(selectedPerfabObj, W.transform.position, W.transform.rotation, W.transform.parent.transform);
        //replaceItem.GetComponent<TileState>().lNumber = selectedObj.GetComponent<TileState>().lNumber;
        //replaceItem.GetComponent<TileState>().hNumber = selectedObj.GetComponent<TileState>().hNumber;
        Destroy(childPast);
       map_Item[selectedObj.GetComponent<TileState>().hNumber, selectedObj.GetComponent<TileState>().lNumber-1] = replaceItem;

    }
    public void A_Link(GameObject A)
    {
        setUpLinkedTubeItem(A.transform.parent.gameObject);
        GameObject childPast = A.gameObject;
        GameObject replaceItem = (GameObject)Instantiate(selectedPerfabObj, A.transform.position, A.transform.rotation, A.transform.parent.transform);
        //replaceItem.GetComponent<TileState>().lNumber = selectedObj.GetComponent<TileState>().lNumber;
        //replaceItem.GetComponent<TileState>().hNumber = selectedObj.GetComponent<TileState>().hNumber;
        Destroy(childPast);
       map_Item[selectedObj.GetComponent<TileState>().hNumber-1, selectedObj.GetComponent<TileState>().lNumber] = replaceItem;

    }
    public void S_Link(GameObject S)
    {
        setUpLinkedTubeItem(S.transform.parent.gameObject);
        GameObject childPast = S.gameObject;
        GameObject replaceItem = (GameObject)Instantiate(selectedPerfabObj, S.transform.position, S.transform.rotation, S.transform.parent.transform);
        //replaceItem.GetComponent<TileState>().lNumber = selectedObj.GetComponent<TileState>().lNumber;
        //replaceItem.GetComponent<TileState>().hNumber = selectedObj.GetComponent<TileState>().hNumber;
        Destroy(childPast);
       map_Item[selectedObj.GetComponent<TileState>().hNumber, selectedObj.GetComponent<TileState>().lNumber+1] = replaceItem;

    }
    public void D_Link(GameObject D)
    {
        setUpLinkedTubeItem(D.transform.parent.gameObject);
        GameObject childPast = D.gameObject;
        GameObject replaceItem = (GameObject)Instantiate(selectedPerfabObj, D.transform.position, D.transform.rotation, D.transform.parent.transform);
        //replaceItem.GetComponent<TileState>().lNumber = selectedObj.GetComponent<TileState>().lNumber;
        //replaceItem.GetComponent<TileState>().hNumber = selectedObj.GetComponent<TileState>().hNumber;
        Destroy(childPast);
       map_Item[selectedObj.GetComponent<TileState>().hNumber+1, selectedObj.GetComponent<TileState>().lNumber] = replaceItem;

    }
    public void changeTubePerfab(
        GameObject putIn, GameObject W, GameObject A, GameObject S, GameObject D,
        GameObject Single, GameObject Cross,
        GameObject wEnd, GameObject sEnd, GameObject aEnd, GameObject dEnd,
        GameObject AD, GameObject WS, GameObject WD, GameObject WA, GameObject AS, GameObject SD,
        GameObject WSA, GameObject WSD, GameObject AWD, GameObject ASD)
    {
        int checkNum = putIn.GetComponent<ItemState>().tubeNumForCheck;

        if (W.GetComponent<ItemState>().tubeNumForCheck != checkNum
            && A.GetComponent<ItemState>().tubeNumForCheck != checkNum
            && S.GetComponent<ItemState>().tubeNumForCheck != checkNum
            && D.GetComponent<ItemState>().tubeNumForCheck != checkNum)
        {
            
            selectedPerfabObj = Single;
           
        }//Single
        if (W.GetComponent<ItemState>().tubeNumForCheck == checkNum
             && A.GetComponent<ItemState>().tubeNumForCheck == checkNum
             && S.GetComponent<ItemState>().tubeNumForCheck == checkNum
             && D.GetComponent<ItemState>().tubeNumForCheck == checkNum)
        {
            W_Link(W);
            A_Link(A);
            S_Link(S);
            D_Link(D);
            selectedPerfabObj = Cross;
        }//Cross
        if (W.GetComponent<ItemState>().tubeNumForCheck == checkNum
            && A.GetComponent<ItemState>().tubeNumForCheck != checkNum
            && S.GetComponent<ItemState>().tubeNumForCheck != checkNum
            && D.GetComponent<ItemState>().tubeNumForCheck != checkNum)
        {
            W_Link(W);
            selectedPerfabObj = wEnd;
        }//wEnd
        if (W.GetComponent<ItemState>().tubeNumForCheck != checkNum
            && A.GetComponent<ItemState>().tubeNumForCheck != checkNum
            && S.GetComponent<ItemState>().tubeNumForCheck == checkNum
            && D.GetComponent<ItemState>().tubeNumForCheck != checkNum)
        {
            S_Link(S);
            selectedPerfabObj = sEnd;
        }//sEnd
        if (W.GetComponent<ItemState>().tubeNumForCheck != checkNum
            && A.GetComponent<ItemState>().tubeNumForCheck == checkNum
            && S.GetComponent<ItemState>().tubeNumForCheck != checkNum
            && D.GetComponent<ItemState>().tubeNumForCheck != checkNum)
        {
            A_Link(A);
            selectedPerfabObj = aEnd;
        }//aEnd
        if (W.GetComponent<ItemState>().tubeNumForCheck != checkNum
            && A.GetComponent<ItemState>().tubeNumForCheck != checkNum
            && S.GetComponent<ItemState>().tubeNumForCheck != checkNum
            && D.GetComponent<ItemState>().tubeNumForCheck == checkNum)
        {
            D_Link(D);
            selectedPerfabObj = dEnd;
        }//dEnd
        if (W.GetComponent<ItemState>().tubeNumForCheck != checkNum
            && A.GetComponent<ItemState>().tubeNumForCheck == checkNum
            && S.GetComponent<ItemState>().tubeNumForCheck != checkNum
            && D.GetComponent<ItemState>().tubeNumForCheck == checkNum)
        {
            
            A_Link(A);
            
            D_Link(D);
            selectedPerfabObj = AD;
        }//AD
        if (W.GetComponent<ItemState>().tubeNumForCheck == checkNum
            && A.GetComponent<ItemState>().tubeNumForCheck != checkNum
            && S.GetComponent<ItemState>().tubeNumForCheck == checkNum
            && D.GetComponent<ItemState>().tubeNumForCheck != checkNum)
        {
            W_Link(W);
           
            S_Link(S);
            
            selectedPerfabObj = WS;
        }//WS
        if (W.GetComponent<ItemState>().tubeNumForCheck == checkNum
            && A.GetComponent<ItemState>().tubeNumForCheck != checkNum
            && S.GetComponent<ItemState>().tubeNumForCheck != checkNum
            && D.GetComponent<ItemState>().tubeNumForCheck == checkNum)
        {
            W_Link(W);
           
            D_Link(D);
            selectedPerfabObj = WD;
        }//WD
        if (W.GetComponent<ItemState>().tubeNumForCheck == checkNum
            && A.GetComponent<ItemState>().tubeNumForCheck == checkNum
            && S.GetComponent<ItemState>().tubeNumForCheck != checkNum
            && D.GetComponent<ItemState>().tubeNumForCheck != checkNum)
        {
            W_Link(W);
            A_Link(A);
            
            selectedPerfabObj = WA;
        }//WA
        if (W.GetComponent<ItemState>().tubeNumForCheck != checkNum
            && A.GetComponent<ItemState>().tubeNumForCheck == checkNum
            && S.GetComponent<ItemState>().tubeNumForCheck == checkNum
            && D.GetComponent<ItemState>().tubeNumForCheck != checkNum)
        {
           
            A_Link(A);
            S_Link(S);
           
            selectedPerfabObj = AS;
        }//AS
        if (W.GetComponent<ItemState>().tubeNumForCheck != checkNum
            && A.GetComponent<ItemState>().tubeNumForCheck != checkNum
            && S.GetComponent<ItemState>().tubeNumForCheck == checkNum
            && D.GetComponent<ItemState>().tubeNumForCheck == checkNum)
        {
           
            S_Link(S);
            D_Link(D);
            selectedPerfabObj = SD;
        }//SD
        if (W.GetComponent<ItemState>().tubeNumForCheck == checkNum
            && A.GetComponent<ItemState>().tubeNumForCheck == checkNum
            && S.GetComponent<ItemState>().tubeNumForCheck == checkNum
            && D.GetComponent<ItemState>().tubeNumForCheck != checkNum)
        {

            W_Link(W);
            A_Link(A);
            S_Link(S);
           
            selectedPerfabObj = WSA;
        }//WSA
        if (W.GetComponent<ItemState>().tubeNumForCheck == checkNum
            && A.GetComponent<ItemState>().tubeNumForCheck != checkNum
            && S.GetComponent<ItemState>().tubeNumForCheck == checkNum
            && D.GetComponent<ItemState>().tubeNumForCheck == checkNum)
        {
            W_Link(W);
           
            S_Link(S);
            D_Link(D);
            selectedPerfabObj = WSD;
        }//WSD
        if (W.GetComponent<ItemState>().tubeNumForCheck == checkNum
            && A.GetComponent<ItemState>().tubeNumForCheck == checkNum
            && S.GetComponent<ItemState>().tubeNumForCheck != checkNum
            && D.GetComponent<ItemState>().tubeNumForCheck == checkNum)
        {
            W_Link(W);
            A_Link(A);
            
            D_Link(D);
            selectedPerfabObj = AWD;
        }//AWD
        if (W.GetComponent<ItemState>().tubeNumForCheck != checkNum
            && A.GetComponent<ItemState>().tubeNumForCheck == checkNum
            && S.GetComponent<ItemState>().tubeNumForCheck == checkNum
            && D.GetComponent<ItemState>().tubeNumForCheck == checkNum)
        {
           
            A_Link(A);
            S_Link(S);
            D_Link(D);
            selectedPerfabObj = ASD;
        }//ASD
      

    }
    public void changeLinkedTubePerfab(
       GameObject putIn, GameObject W, GameObject A, GameObject S, GameObject D,
       GameObject Single, GameObject Cross,
       GameObject wEnd, GameObject sEnd, GameObject aEnd, GameObject dEnd,
       GameObject AD, GameObject WS, GameObject WD, GameObject WA, GameObject AS, GameObject SD,
       GameObject WSA, GameObject WSD, GameObject AWD, GameObject ASD)
    {
        int checkNum = putIn.GetComponent<ItemState>().tubeNumForCheck;

        if (W.GetComponent<ItemState>().tubeNumForCheck != checkNum
            && A.GetComponent<ItemState>().tubeNumForCheck != checkNum
            && S.GetComponent<ItemState>().tubeNumForCheck != checkNum
            && D.GetComponent<ItemState>().tubeNumForCheck != checkNum)
        {

            selectedPerfabObj = Single;

        }//Single
        if (W.GetComponent<ItemState>().tubeNumForCheck == checkNum
             && A.GetComponent<ItemState>().tubeNumForCheck == checkNum
             && S.GetComponent<ItemState>().tubeNumForCheck == checkNum
             && D.GetComponent<ItemState>().tubeNumForCheck == checkNum)
        {
      
            selectedPerfabObj = Cross;
        }//Cross
        if (W.GetComponent<ItemState>().tubeNumForCheck == checkNum
            && A.GetComponent<ItemState>().tubeNumForCheck != checkNum
            && S.GetComponent<ItemState>().tubeNumForCheck != checkNum
            && D.GetComponent<ItemState>().tubeNumForCheck != checkNum)
        {
           
            selectedPerfabObj = wEnd;
        }//wEnd
        if (W.GetComponent<ItemState>().tubeNumForCheck != checkNum
            && A.GetComponent<ItemState>().tubeNumForCheck != checkNum
            && S.GetComponent<ItemState>().tubeNumForCheck == checkNum
            && D.GetComponent<ItemState>().tubeNumForCheck != checkNum)
        {
        
            selectedPerfabObj = sEnd;
        }//sEnd
        if (W.GetComponent<ItemState>().tubeNumForCheck != checkNum
            && A.GetComponent<ItemState>().tubeNumForCheck == checkNum
            && S.GetComponent<ItemState>().tubeNumForCheck != checkNum
            && D.GetComponent<ItemState>().tubeNumForCheck != checkNum)
        {
          
            selectedPerfabObj = aEnd;
        }//aEnd
        if (W.GetComponent<ItemState>().tubeNumForCheck != checkNum
            && A.GetComponent<ItemState>().tubeNumForCheck != checkNum
            && S.GetComponent<ItemState>().tubeNumForCheck != checkNum
            && D.GetComponent<ItemState>().tubeNumForCheck == checkNum)
        {
      
            selectedPerfabObj = dEnd;
        }//dEnd
        if (W.GetComponent<ItemState>().tubeNumForCheck != checkNum
            && A.GetComponent<ItemState>().tubeNumForCheck == checkNum
            && S.GetComponent<ItemState>().tubeNumForCheck != checkNum
            && D.GetComponent<ItemState>().tubeNumForCheck == checkNum)
        {

         
            selectedPerfabObj = AD;
        }//AD
        if (W.GetComponent<ItemState>().tubeNumForCheck == checkNum
            && A.GetComponent<ItemState>().tubeNumForCheck != checkNum
            && S.GetComponent<ItemState>().tubeNumForCheck == checkNum
            && D.GetComponent<ItemState>().tubeNumForCheck != checkNum)
        {
          

            selectedPerfabObj = WS;
        }//WS
        if (W.GetComponent<ItemState>().tubeNumForCheck == checkNum
            && A.GetComponent<ItemState>().tubeNumForCheck != checkNum
            && S.GetComponent<ItemState>().tubeNumForCheck != checkNum
            && D.GetComponent<ItemState>().tubeNumForCheck == checkNum)
        {
          
            selectedPerfabObj = WD;
        }//WD
        if (W.GetComponent<ItemState>().tubeNumForCheck == checkNum
            && A.GetComponent<ItemState>().tubeNumForCheck == checkNum
            && S.GetComponent<ItemState>().tubeNumForCheck != checkNum
            && D.GetComponent<ItemState>().tubeNumForCheck != checkNum)
        {
         

            selectedPerfabObj = WA;
        }//WA
        if (W.GetComponent<ItemState>().tubeNumForCheck != checkNum
            && A.GetComponent<ItemState>().tubeNumForCheck == checkNum
            && S.GetComponent<ItemState>().tubeNumForCheck == checkNum
            && D.GetComponent<ItemState>().tubeNumForCheck != checkNum)
        {


            selectedPerfabObj = AS;
        }//AS
        if (W.GetComponent<ItemState>().tubeNumForCheck != checkNum
            && A.GetComponent<ItemState>().tubeNumForCheck != checkNum
            && S.GetComponent<ItemState>().tubeNumForCheck == checkNum
            && D.GetComponent<ItemState>().tubeNumForCheck == checkNum)
        {

        
            selectedPerfabObj = SD;
        }//SD
        if (W.GetComponent<ItemState>().tubeNumForCheck == checkNum
            && A.GetComponent<ItemState>().tubeNumForCheck == checkNum
            && S.GetComponent<ItemState>().tubeNumForCheck == checkNum
            && D.GetComponent<ItemState>().tubeNumForCheck != checkNum)
        {


            selectedPerfabObj = WSA;
        }//WSA
        if (W.GetComponent<ItemState>().tubeNumForCheck == checkNum
            && A.GetComponent<ItemState>().tubeNumForCheck != checkNum
            && S.GetComponent<ItemState>().tubeNumForCheck == checkNum
            && D.GetComponent<ItemState>().tubeNumForCheck == checkNum)
        {
           
            selectedPerfabObj = WSD;
        }//WSD
        if (W.GetComponent<ItemState>().tubeNumForCheck == checkNum
            && A.GetComponent<ItemState>().tubeNumForCheck == checkNum
            && S.GetComponent<ItemState>().tubeNumForCheck != checkNum
            && D.GetComponent<ItemState>().tubeNumForCheck == checkNum)
        {
          

       
            selectedPerfabObj = AWD;
        }//AWD
        if (W.GetComponent<ItemState>().tubeNumForCheck != checkNum
            && A.GetComponent<ItemState>().tubeNumForCheck == checkNum
            && S.GetComponent<ItemState>().tubeNumForCheck == checkNum
            && D.GetComponent<ItemState>().tubeNumForCheck == checkNum)
        {

       
            selectedPerfabObj = ASD;
        }//ASD


    }
    // Update is called once per frame
    public GameObject item_Null;
    static public GameObject Single;
    static public GameObject Cross;
    static public GameObject wEnd;
    static public GameObject sEnd;
    static public GameObject aEnd;
    static public GameObject dEnd;
    static public GameObject AD;
    static public GameObject WS;
    static public GameObject WD;
    static public GameObject WA;
    static public GameObject AS;
    static public GameObject SD;
    static public GameObject WSA;
    static public GameObject WSD;
    static public GameObject AWD;
    static public GameObject ASD;
    public void setUpTubeItem(GameObject objToChange)
    {
        if (selectedPerfabObj.tag == "tube")
        {
            GameObject W, A, S, D;
            //有错误
            if (objToChange.GetComponent<TileState>().hNumber> 0)
            { A = MapMaker.map_Item[objToChange.GetComponent<TileState>().hNumber - 1, objToChange.GetComponent<TileState>().lNumber]; }
            else { A = item_Null; }
            if (objToChange.GetComponent<TileState>().lNumber> 0)
            { W = MapMaker.map_Item[objToChange.GetComponent<TileState>().hNumber, objToChange.GetComponent<TileState>().lNumber - 1]; }
            else { W = item_Null; }
            if (objToChange.GetComponent<TileState>().hNumber < mapHeight-1)
            { D = MapMaker.map_Item[objToChange.GetComponent<TileState>().hNumber + 1, objToChange.GetComponent<TileState>().lNumber]; }
            else { D = item_Null; }
            if (objToChange.GetComponent<TileState>().lNumber < mapLength-1)
            { S = MapMaker.map_Item[objToChange.GetComponent<TileState>().hNumber, objToChange.GetComponent<TileState>().lNumber + 1]; }
            else { S = item_Null; }
            Debug.Log(D.name);

            changeTubePerfab(
            selectedPerfabObj,
            W,
            A,
            S,
            D,
            Single,
            Cross,
            wEnd,
            sEnd,
            aEnd,
            dEnd,
            AD,
            WS,
            WD,
            WA,
            AS,
            SD,
            WSA,
            WSD,
            AWD,
            ASD
            );
        }

    }
    public void setUpLinkedTubeItem(GameObject objToChange)
    {
        if (selectedPerfabObj.tag == "tube")
        {
            GameObject W, A, S, D;
            //有错误
            if (objToChange.GetComponent<TileState>().hNumber > 0)
            { A = MapMaker.map_Item[objToChange.GetComponent<TileState>().hNumber - 1, objToChange.GetComponent<TileState>().lNumber]; }
            else { A = item_Null; }
            if (objToChange.GetComponent<TileState>().lNumber > 0)
            { W = MapMaker.map_Item[objToChange.GetComponent<TileState>().hNumber, objToChange.GetComponent<TileState>().lNumber - 1]; }
            else { W = item_Null; }
            if (objToChange.GetComponent<TileState>().hNumber < mapHeight - 1)
            { D = MapMaker.map_Item[objToChange.GetComponent<TileState>().hNumber + 1, objToChange.GetComponent<TileState>().lNumber]; }
            else { D = item_Null; }
            if (objToChange.GetComponent<TileState>().lNumber < mapLength - 1)
            { S = MapMaker.map_Item[objToChange.GetComponent<TileState>().hNumber, objToChange.GetComponent<TileState>().lNumber + 1]; }
            else { S = item_Null; }
            Debug.Log(D.name+"sssssssssssss");

            changeLinkedTubePerfab(
            selectedPerfabObj,
            W,
            A,
            S,
            D,
            Single,
            Cross,
            wEnd,
            sEnd,
            aEnd,
            dEnd,
            AD,
            WS,
            WD,
            WA,
            AS,
            SD,
            WSA,
            WSD,
            AWD,
            ASD
            );
        }

    }
    float timeCut=0;
    void Update()
    {

        if (Input.GetMouseButton(0))
        {
            Ray ray = Camera.main.ScreenPointToRay(Input.mousePosition);
            RaycastHit hit;
            if (Physics.Raycast(ray, out hit, 1000f))
            {

                //Debug.Log("RayCast");
                if (hit.collider.tag == "tile")
                {
                    selectedObj = hit.collider.gameObject;
                    if (selectedPerfabObj)
                        if (selectedPerfabObj.GetComponent<TileState>())
                        {
                            changeMap(selectedPerfabObj);
                        }
                        
                        else { changeItemInMap(); }
                }
            }
        }
    }
}