﻿using UnityEngine;

public class CameraControl : MonoBehaviour
{
    public bool moveCamera = true;                        // Toggle for whether the camera's rig should rotate to look at the player.
    public Vector3 offset = new Vector3 (0f, 1.5f, 0f);   // The offset from the player's position that the camera should look at.
    public Transform playerPosition;                      // The player's position in the scene.


    private void Update ()
    {
        // If the rig should move, rotate it to look at an offset from the player's position.
        if (moveCamera)
            transform.LookAt (playerPosition.position + offset);
    }
}