﻿using UnityEngine;

public class PersistentDataController : MonoBehaviour
{
    public PersistentDataObject persistentDataObject;
    public GameObject persistentActivityGameObject;
    public Behaviour persistentEnabledBehaviour;
    public Interactable persistentUsedInteractable;
    public Transform persistentPositionTransform;
    public Transform persistentRotationTransform;


    public void Load ()
    {
		/*
        if (persistentActivityGameObject)
        {
            persistentActivityGameObject.SetActive (persistentDataObject.activityState);
        }
		*/
        if (persistentEnabledBehaviour)
        {
            persistentEnabledBehaviour.enabled = persistentDataObject.enabledState;
        }

        if (persistentUsedInteractable)
        {
            persistentUsedInteractable.isUsed = persistentDataObject.interactableUsedState;
        }

        if (persistentPositionTransform)
        {
            persistentPositionTransform.position = persistentDataObject.position;
        }

        if (persistentRotationTransform)
        {
            persistentRotationTransform.rotation = persistentDataObject.rotation;
        }
    }


    public void Save ()
    {
		/*
        if (persistentActivityGameObject)
        {
            persistentDataObject.activityState = persistentActivityGameObject.activeSelf;
        }
		*/
        if (persistentEnabledBehaviour)
        {
            persistentDataObject.enabledState = persistentEnabledBehaviour.enabled;
        }

        if (persistentUsedInteractable)
        {
            persistentDataObject.interactableUsedState = persistentUsedInteractable.isUsed;
        }

        if (persistentPositionTransform)
        {
            persistentDataObject.position = persistentPositionTransform.position;
        }

        if (persistentRotationTransform)
        {
            persistentDataObject.rotation = persistentRotationTransform.rotation;
        }
    }
}
