﻿using UnityEngine;

[CreateAssetMenu]
public class PersistentDataObject : ScriptableObject
{
    public bool defaultActivityState;
    public bool defaultEnabledState;
    public bool defaultInteractableUsedState;
    public Vector3 defaultPosition;
    public Vector3 defaultRotation;


    [HideInInspector] public bool activityState;
    [HideInInspector] public bool enabledState;
    [HideInInspector] public bool interactableUsedState;
    [HideInInspector] public Vector3 position;
    [HideInInspector] public Quaternion rotation;


    public void ResetToDefaults ()
    {
		
        activityState = defaultActivityState;
        enabledState = defaultEnabledState;
        interactableUsedState = defaultInteractableUsedState;
        position = defaultPosition;
        rotation = Quaternion.Euler (defaultRotation);
		
	}
}
