﻿using System;
using UnityEngine;

[Serializable]
public class Condition
{
    [Serializable]
    public class HitTargetKindItemCondition
    {
        public bool reSetHitObj;
        public GameObject targetKindItem;
        public GameObject triggerObj;
        //public bool isTarget;


        public bool TryCheck()
        {
            bool isConditionMet;
            if (DebugTrigger.debugBool)
                Debug.Log("hitTryCheck1");
            if (targetKindItem)
            {
                if (triggerObj.GetComponent<ColliderTrigger>().hitObj == null)
                {
                    isConditionMet = false;
                }
                else
                {
                    if(DebugTrigger.debugBool)
                    Debug.Log("hitTryCheck2");
                    isConditionMet = (triggerObj.GetComponent<ColliderTrigger>().hitObj.GetComponent<ItemState>().itemNumForSaving
                        == targetKindItem.GetComponent<ItemState>().itemNumForSaving
                        && triggerObj.GetComponent<ColliderTrigger>().hitObj.GetComponent<Interactable>().isUsed == false);
                    if (DebugTrigger.debugBool)
                        Debug.Log("hitTryCheck3");
                    if (isConditionMet)
                        if (DebugTrigger.debugBool)
                            Debug.Log("hitTryCheck4");
                }
                if(reSetHitObj)
                triggerObj.GetComponent<ColliderTrigger>().hitObj = null;
            }
            else
            {
                isConditionMet = true;
            }

            return isConditionMet;
        }
    }
    [Serializable]
    public class ExitHitTargetKindItemCondition
    {
        public bool reSetHitExitObj;
        public GameObject targetKindItem;
        public GameObject triggerObj;
        //public bool isTarget;


        public bool TryCheck()
        {
            bool isConditionMet;
            if (DebugTrigger.debugBool)
                Debug.Log("noHitExitExitHitTargetKindItemCondition  noHitExit1");
            if (targetKindItem)
            {
                if (triggerObj.GetComponent<ColliderTrigger>().hitObjExit == null)
                { isConditionMet = false; }
                else {
                    if (DebugTrigger.debugBool)
                        Debug.Log("ExitHitTargetKindItemCondition2");
                isConditionMet = (triggerObj.GetComponent<ColliderTrigger>().hitObjExit.GetComponent<ItemState>().itemNumForSaving
                    == targetKindItem.GetComponent<ItemState>().itemNumForSaving
                    && triggerObj.GetComponent<ColliderTrigger>().hitObjExit.GetComponent<Interactable>().isUsed == false);
                    if (DebugTrigger.debugBool)
                        Debug.Log("ExitHitTargetKindItemCondition3");
                if (isConditionMet)
                        if (DebugTrigger.debugBool)
                            Debug.Log("ExitHitTargetKindItemCondition4");
                }
                if(reSetHitExitObj)
                triggerObj.GetComponent<ColliderTrigger>().hitObjExit = null;
            }
            else
            {
                isConditionMet = true;
            }

            return isConditionMet;
        }
    }


    [Serializable]
    public class GameObjectCondition
    {
        public GameObject gameObject;
        public bool activityState;


        public bool TryCheck ()
        {
            bool isConditionMet;

            if (gameObject)
            {
				isConditionMet = (gameObject.activeSelf == activityState);
            }
            else
            {
                isConditionMet = true;
            }

            return isConditionMet;
        }
    }


    //[Serializable]
    //public class EquippedItemCondition
    //{
   //     public Item equippedItem;


   //     public bool TryCheck (Inventory inventory)
   //     {
			//bool isConditionMet;

			//if (equippedItem)
			//{
			//	isConditionMet = inventory.IsItemEquipped(equippedItem);
			//}
			//else
			//{
			//	isConditionMet = true;
			//}

			//return isConditionMet;
   //     }
    //}


    //[Serializable]
    //public class CarriedItemCondition
    //{
   //     public Item carriedItem;


   //     public bool TryCheck (Inventory inventory)
   //     {
			//bool isConditionMet;

			//if (carriedItem)
			//{
			//	isConditionMet = inventory.IsItemCarried(carriedItem);
			//}
			//else
			//{
			//	isConditionMet = true;
			//}

			//return isConditionMet;
   //     }
    //}


    [Serializable]
    public class InteractableCondition
    {
        public Interactable interactable;
        public bool usedState;


        public bool TryCheck ()
        {
			bool isConditionMet;

			if (interactable)
			{
				isConditionMet = (interactable.isUsed == usedState);
			}
			else
			{
				isConditionMet = true;
			}

			return isConditionMet;
        }
    }


    public string description;
    public ExitHitTargetKindItemCondition[] exitHitTargetKindItemConditionn;
    public HitTargetKindItemCondition[] hitTargetKindItemCondition;
    public GameObjectCondition[] gameObjectConditions;
    //public EquippedItemCondition[] equippedItemConditions;
    //public CarriedItemCondition[] carriedItemConditions;
    public InteractableCondition[] interactableConditions;
    public Reaction reaction;


	public bool Check ()
    {
        bool isConditionMet = true;
        for (int i = 0; i < exitHitTargetKindItemConditionn.Length; i++)
        {
            isConditionMet = isConditionMet && exitHitTargetKindItemConditionn[i].TryCheck();
        }
        for (int i = 0; i < hitTargetKindItemCondition.Length; i++)
        {
            isConditionMet = isConditionMet && hitTargetKindItemCondition[i].TryCheck();
        }
        for (int i = 0; i < gameObjectConditions.Length; i++)
        {
            isConditionMet = isConditionMet && gameObjectConditions[i].TryCheck ();
        }

        //for (int i = 0; i < equippedItemConditions.Length; i++)
        //{
        //    isConditionMet = isConditionMet && equippedItemConditions[i].TryCheck (inventory);
        //}

        //for (int i = 0; i < carriedItemConditions.Length; i++)
        //{
        //    isConditionMet = isConditionMet && carriedItemConditions[i].TryCheck (inventory);
        //}

        for (int i = 0; i < interactableConditions.Length; i++)
        {
            isConditionMet = isConditionMet && interactableConditions[i].TryCheck ();
        }

        return isConditionMet;
    }


	public void React ()
	{
		if (reaction != null) {
			reaction.React ();
		}
	}

}
