﻿using UnityEngine;

public class Interactable : MonoBehaviour
{
    public Transform interactionLocation;
    public bool isUsed;
    public Condition[] conditions;
    public Reaction defaultReaction;


	private Inventory inventory;


	private void Start ()
	{
		inventory = FindObjectOfType<Inventory> ();
	}


    public void Interact ()
    {
		bool hasReactedToCondition = false;

		for (int i = 0; i < conditions.Length; i++)
		{
			if (conditions [i].Check ())
			{
				conditions [i].React ();
				hasReactedToCondition = true;
				break;
			}
		}

		if (!hasReactedToCondition && defaultReaction)
		{
			defaultReaction.React ();
		}
    }
}
